Index: anr/section-2.2.tex
===================================================================
--- anr/section-2.2.tex	(revision 177)
+++ anr/section-2.2.tex	(revision 191)
@@ -1,8 +1,3 @@
-
 % Relevance of the proposal 
-
-
-
-
 The COACH proposal addresses directly the \emph{Embedded Systems} item of
 the ARPEGE program. It aims to propose solutions to the societal/economical challenges by
@@ -28,6 +23,4 @@
 environment, suitable for co-operative and distributed development.
 \end{itemize}
-%%%
-\parlf
 COACH outcome will contribute to strengthen Europe's competitive position by developing
 technologies and methodologies for product development, focusing (in compliance with the
@@ -37,11 +30,13 @@
 manufacturing and integration of devices and related software into end-products.
 %%%
-\parlf
+\parlf\noindent
 The COACH project will benefit from a number of previous recent projects:
 \begin{description}
   \item[SOCLIB]
-    The SoCLib ANR platform (2007-2009) is an open infrastructure developped by 10 academic laboratories 
-    (TIMA, LIP6, Lab-STICC, IRISA, ENST, Gipsa-Lab, CEA-LIST, CEA-LETI, CITI, INRIA-Futurs, LIS) and 6 
-	industrial companies (Thales Communications, Thomson R\&D, STMicroelectronics, Silicomp, MDS, TurboConcept). 
+    The SoCLib ANR platform (2007-2009) is an open infrastructure developped by
+    10 academic laboratories and and 6 industrial companies.
+%    \mustbecompleted{10 FIXME il y a 11 noms dans la liste :(} academic laboratories 
+%    (TIMA, LIP6, Lab-STICC, IRISA, ENST, Gipsa-Lab, CEA-LIST, CEA-LETI, CITI, INRIA-Futurs, LIS) and 6 
+%    industrial companies (Thales Communications, Thomson R\&D, STMicroelectronics, Silicomp, MDS, TurboConcept). 
     It supports system level virtual prototyping of shared memory, multi-processors
     architectures, and provides tools to map multi-tasks software application on these
@@ -79,5 +74,5 @@
 \end{description}
 %%%
-\parlf
+\parlf\noindent
 The laboratories involved in the COACH project have a well estabished expertise
 in the following domains:
@@ -111,11 +106,9 @@
 \end{itemize}
 %%%
-
-
+\parlf\noindent
 The COACH project answers to several of the challenges found in different axis of the 
-call for proposals. Keywords of the call are indicated below in italic writing.
-
-Axis 1 "Architectures des syst\`{e}mes embarqu\'{e}s" :
-
+call for proposals.%Keywords of the call are indicated below in italic writing.
+\begin{description}
+\item[Axis 1] \textit{Architectures des syst\`{e}mes embarqu\'{e}s} \\
 COACH will address new embedded systems architectures by allowing the design of 
 Multi-Core Systems-on-Chip (possibly heterogeneous) on FPGA according to the design 
@@ -124,8 +117,8 @@
 running Embedded Software, as well as an Operating System with associated middleware and 
 API and using hardware accelerator automatically generated. It will also permit to use 
-efficiently different dynamic system management techniques and re-configuration mechanisms. 
-
-Axis 2 "Infrastructures pour l'Internet, le calcul intensif ou les services" :
-
+efficiently different dynamic system management techniques and re-configuration mechanisms.
+\textbf{Thereby COACH well corresponds to axis 1}.
+%
+\item[Axis 2] \textit{Infrastructures pour l'Internet, le calcul intensif ou les services} \\
 COACH will address High-Performance Computing (HPC) by helping designer to accelerate an 
 application running on a PC by migrating critical parts into a SoC implemented on an FPGA 
@@ -134,33 +127,63 @@
 configurations. Moreover, Dynamic Partial Reconfiguration will be used for improving HPC performance 
 as well as reducing the required area.
+\textbf{Thereby COACH partially corresponds to axis 2}.
+%
+% IA2PC: comme ce sont des axes tertiaire, il faut faire + court que primaire et
+% IA2PC: secondaire.
+\item[Axis 3 \& 5] \textit{Robotique et contr\^{o}le/commande} and \textit{S\'{e}curit\'{e} et suret\'{e}} \\
+%VERS 1
+%Future control applications employ more and more SoC.
+%Application domains for such systems are for example the automotive domain, as well as the
+%aerospace and avionics domains.
+%In all cases, high performance and real time requirements are combined with 
+%requirements to low power, low temperature, high dependability, and low cost.\\
+%Similary manufacturing, security and safety technologies require also more and more
+%computation power. 
+%VERS 2 pour gagner de la place
+Manufacturing, controling, security and safety technologies employ more and more SoC.
+COACH will permit to design such complex digital systems.
+\textbf{Thereby COACH indirectly answers to axis 3 and 5 too}.
+\end{description}
+%Axis 3 "Robotique et contr\^{o}le/commande}"
+%
+%COACH will permit to design complex digital systems based on high-performance multi-core systems.
+%Like in the consumer electronics domain (telecommunication, multimedia), future control applications 
+%will employ more and more SoC not just for typical consumer functionality, but also for safety and 
+%security applications (by performing complex analyses on data gathered with intelligent sensors, 
+%by initiating appropriate responses to dangerous phenomena...). Application domains for such systems 
+%are for example the automotive domain, as well as the aerospace and avionics domains (i.e. sophisticated on-board 
+%radar systems, collision-detection, intelligent navigation...). 
+%Manufacturing technology will also increasingly need high-end vision analysis and high-speed 
+%robot control. In all cases, high performance and real time requirements are combined with 
+%requirements to low power, low temperature, high dependability, and low cost.
+%
+%Axis 5 "S\'{e}curit\'{e} et suret\'{e}" :
+%
+%The results of the COACH project will help users to build cryptographic secure systems implemented in
+%hardware or both in software/ hardware in an effective way, substantially enhancing the
+%process productivity of the cryptographic algorithms hardware synthesis, improving the
+%quality and reducing the design time and the cost of synthesised cryptographic devices.
 
-Axis 3 "Robotique et controle/commande" :
-
-COACH will permit to design complex digital systems based on high-performance multi-core systems.
-Like in the consumer electronics domain (telecommunication, multimedia), future control applications 
-will employ more and more SoC not just for typical consumer functionality, but also for safety and 
-security applications (by performing complex analyses on data gathered with intelligent sensors, 
-by initiating appropriate responses to dangerous phenomena...). Application domains for such systems 
-are for example the automotive domain, as well as the aerospace and avionics domains (i.e. sophisticated on-board 
-radar systems, collision-detection, intelligent navigation...). 
-Manufacturing technology will also increasingly need high-end vision analysis and high-speed 
-robot control. In all cases, high performance and real time requirements are combined with 
-requirements to low power, low temperature, high dependability, and low cost.
-
-Axis 5 "S\'{e}curit\'{e} et suret\'{e}" :
-
-The results of the COACH project will help users to build cryptographic secure systems implemented in
-hardware or both in software/ hardware in an effective way, substantially enhancing the
-process productivity of the cryptographic algorithms hardware synthesis, improving the
-quality and reducing the design time and the cost of synthesised cryptographic devices.
-
-COACH technologies can be used in both large and small business, as they will permit users to design
-embedded systems which meet a wide range of requirements: from low cost and low power consuming
-devices to very high speed devices, based on parallel computing. For enterprises that will use embedded
-systems designed via the approaches and tools targeted by COACH, there is the potential for greater
-efficiency, improved business processes and models. The net results: lower costs, faster response times,
-better service, and higher revenue.
-
-
+% IA2PC: 1) je ne vois pas trop ce que ca fait la.
+% IA2PC: 2) c'est deja dans le 2.1 pour le small business.
+% IA2PC: 3) Pour le large business, on avait mis ca dans la premiere version et je pense
+% IA2PC     toujours que le large business est encore vise par COACH.
+% IA2PC     Alain a enleve toute reference sur ce large business. Sa raison est +
+% IA2PC     politico/stylistique: en parlant des 2 on n'est pas tres clair et on brouille
+% IA2PC     le message. Je partage assez son avis, la version actuelle est + claire que
+% IA2PC     celle d'avant. De plus on ne dit jamais que l'on ne vise pas les grosses
+% IA2PC     boites.
+% IA2PC
+% IA2PC Bref je serai assez pour enlever ce paragraphe, et ne pas faire reference au large
+% IA2PC business meme dans les section precedente. Par contre d'essayer de recaser le reste dans
+% IA2PC les sections precedentes.
+%
+% VERS 2 pour gagner de la place je l'enleve
+% COACH technologies can be used in both large and small business, as they will permit users to design
+% embedded systems which meet a wide range of requirements: from low cost and low power consuming
+% devices to very high speed devices, based on parallel computing. For enterprises that will use embedded
+% systems designed via the approaches and tools targeted by COACH, there is the potential for greater
+% efficiency, improved business processes and models. The net results: lower costs, faster response times,
+% better service, and higher revenue.
 \parlf
 Finally, it is worth to note that this project covers priorities defined by the commission 
@@ -168,4 +191,4 @@
 Systems: $<<$Concepts, methods and tools for designing systems dealing with systems complexity
 and allowing to apply efficiently applications and various products on embedded platforms,
-considering resources constraints (delais, power, memory, etc.), security and quality
+considering resources constraints (delays, power, memory, etc.), security and quality
 services$>>$.