Index: anr/task-1.tex
===================================================================
--- anr/task-1.tex	(revision 187)
+++ anr/task-1.tex	(revision 202)
@@ -40,10 +40,10 @@
         The final version of the {\specGenManualI} deliverable updated with the first 
 	    feed-backs of the demonstrator \STs.
-    \itemV{0}{6}{d}{\Subs}{HAS specification} \setMacroInAuxFile{specHasManualI}
+    \itemV{0}{6}{d}{\Subs}{HAS specification}{1:0:0} \setMacroInAuxFile{specHasManualI}
         The first version of the HAS (Hardware Accelerator Synthesis) specification.
         It specifies how tasks must be written (C/C++ subset) and how
         communication schemes defined in the {\specCsgManual} deliverable must be described for
         coprocessor synthesis.
-    \itemL{6}{12}{d}{\Subs}{HAS specification}{1:2:3} \setMacroInAuxFile{specHasManual}
+    \itemL{6}{12}{d}{\Subs}{HAS specification}{1:0:0} \setMacroInAuxFile{specHasManual}
         The final version of the {\specGenManualI} deliverable updated with the first 
 	    feed-backs of the demonstrator \STs.
@@ -71,19 +71,19 @@
         Last release of XML specification of the \xcoach format enhanced with
         the expression of loop potential parallelism.
-    \itemV{6}{12}{x}{\Subs}{C/C++ $\leftrightarrow$ \xcoach format (1)}
+    \itemV{6}{12}{x}{\Subs}{C/C++ $\leftrightarrow$ \xcoach format (1)}{3:0:0}
         \setMacroInAuxFile{specXcoachToCAI}
         A GCC plugin C2X that generates a \xcoach description
         (defined in {\specXcoachDocI} deliverable) from a C/C++ task description
         (defined in {\specHasManual} deliverable).
-    \itemL{12}{18}{x}{\Subs}{C++ $\leftrightarrow$ \xcoach format (1)}{0:0:0}
+    \itemL{12}{18}{x}{\Subs}{C++ $\leftrightarrow$ \xcoach format (1)}{0:1:0}
         \setMacroInAuxFile{specXcoachToCA}
         The same software as the former (\specXcoachToCAI) but for \xcoach format defined
         in the {\specXcoachDoc} deliverable and HAS input defined in the {\specHasManual}
         deliverable.
-    \itemV{7}{12}{x}{\Subs}{C/C++ $\leftrightarrow$ \xcoach format (2)}
+    \itemV{7}{12}{x}{\Subs}{C/C++ $\leftrightarrow$ \xcoach format (2)}{3:0:0}
         \setMacroInAuxFile{specXcoachToCBI}
         This second tool X2C regenerates a C description from a \xcoach
         description.
-    \itemL{12}{18}{x}{\Subs}{C++ $\leftrightarrow$ \xcoach format (2)}{0:0:0}
+    \itemL{12}{18}{x}{\Subs}{C++ $\leftrightarrow$ \xcoach format (2)}{0:1:0}
         \setMacroInAuxFile{specXcoachToCB}
         The same software as the former (\specXcoachToCBI) but for the \xcoach format as defined
@@ -97,9 +97,9 @@
         \setMacroInAuxFile{specXcoachToSystemC}
         Final release of the former software (\specXcoachToSystemCI).
-    \itemV{12}{18}{x}{\Subs}{\xcoachplus format to VHDL}
+    \itemV{12}{18}{x}{\Subs}{\xcoachplus format to VHDL}{0:3:0}
         \setMacroInAuxFile{specXcoachToVhdlI}
         The first release of the softwaretool X2VHDL that translates \xcoachplus description to
         synthesizable VHDL description.
-    \itemL{18}{24}{x}{\Subs}{\xcoachplus format to VHDL}{0:0:0}
+    \itemL{18}{24}{x}{\Subs}{\xcoachplus format to VHDL}{0:1:0}
         \setMacroInAuxFile{specXcoachToVhdl}
         Final release of the former software (\specXcoachToVhdlI) and integration
@@ -116,10 +116,10 @@
 \subtask This \ST aims to define a tool in order to pilot the GCC/xcoach compiler.
     \begin{livrable}
-    \itemL{0}{3}{d}{\Subs}{GCC/xcoach driver definition}{0:0:0}
+    \itemL{0}{3}{d}{\Subs}{GCC/xcoach driver definition}{1:0:0}
         Specification of the GCC driver tool.
-    \itemL{3}{9}{x}{\Subs}{GCC/xcoach driver generator}{0:0:0}
+    \itemL{3}{9}{x}{\Subs}{GCC/xcoach driver generator}{2:0:0}
         First release of the GCC driver tool.
 	%en T0+18 car va peut etre evoluer en fonction du DSE Âµ-archi
-    \itemL{9}{12}{x}{\Subs}{GCC/xcoach driver generator}{0:0:0}
+    \itemL{9}{12}{x}{\Subs}{GCC/xcoach driver generator}{1:0:0}
         Final release of the GCC driver tool.
     \end{livrable}